Name:           clasp
Version:        3.3.2
Release:        1%{?dist}
Summary:        A conflict-driven nogood learning answer set solver

Group:          Development/Libraries
License:        MIT
URL:            http://potassco.org/clasp/
Source0:        https://github.com/potassco/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz
Patch0:         %{name}-3.3.2-install_dir.patch
Patch1:         %{name}-3.3.2-header_install.patch
Patch2:         %{name}-3.3.2-cmake-deps.patch

BuildRequires:  cmake
BuildRequires:  libpotassco-devel

%description
clasp is an answer set solver for (extended) normal and disjunctive logic
programs. It is part of the Potassco project for Answer Set Programming (ASP).
The primary algorithm of clasp relies on conflict-driven nogood learning, a
technique that proved very successful for satisfiability checking (SAT). clasp
has been genuinely developed for answer set solving but can also be applied as a
(Max-)SAT or PB solver or as a C++ library in another program. It provides
different reasoning modes and other advanced features including:

- Enumeration and Optimization of (Projected) Solutions,
- Cautious and Brave Reasoning,
- Advanced Disjunctive Solving,
- Parallel (multithreaded) solving,
- Domain heuristic modifications,
- Unsatisfiable-core based optimization,
- ASP/SAT/PB modulo acyclicity,
- Different input formats including smodels, aspif, dimacs and opb.

Detailed information (including a User's manual), source code, and pre-compiled
binaries are available at: http://potassco.org/

%package devel
Summary:        Development files for clasp
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
Header and cmake modules for clasp, a conflict-driven nogood learning answer set
solver.

Detailed information (including a User's manual), source code, and pre-compiled
binaries are available at: http://potassco.org/

%package doc
Summary:        Documentation for clasp
Recommends:     %{name} = %{version}-%{release}
BuildRequires:  doxygen

BuildArch:      noarch

%description doc
Generated HTML documentation for clasp, a conflict-driven nogood learning answer
set solver.

Detailed information (including a User's manual), source code, and pre-compiled
binaries are available at: http://potassco.org/

%prep
%autosetup -p1

# unbundle libpotassco
rm -rf libpotassco

%build
mkdir -p build && pushd build
%cmake .. \
  -DCLASP_BUILD_TESTS:BOOL=ON \
  -DCLASP_INSTALL_LIB:BOOL=ON \
  %{nil}
popd

make %{?_smp_mflags} -C build all doc_clasp

%install
%make_install -C build

%check
make %{?_smp_mflag} -C build test

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%doc CHANGES README.md
%license LICENSE
%{_bindir}/%{name}
%{_libdir}/lib%{name}.so

%files devel
%{_includedir}/%{name}/
%{_libdir}/cmake/%{name}/

%files doc
%doc doc/api/html
%license LICENSE

%changelog
* Sun Aug 20 2017 Scott K Logan <logans@cottsay.net> - 3.3.2-1
- Initial package
